% Import prbhu kloubovch promnnch polohy, rychlosti a zrychlen - soubor q_dq_ddq.txt
Data1 = importdata('q_dq_ddq.txt');

% Create new variables in the base workspace from those fields.
vars = fieldnames(Data1);
for i = 1:length(vars)
    assignin('base', vars{i}, Data1.(vars{i}));
end
% Poet hodnot prbh
n_index=length(Data1.data);

run struktura;

Time=zeros(n_index,1);

q=zeros(n_index,ndof);
dq=zeros(n_index,ndof);
ddq=zeros(n_index,ndof);

pol_last_LCS=zeros(n_index,ndof);
vel_last_LCS=zeros(n_index,ndof);
acc_last_LCS=zeros(n_index,ndof);

Time(:)=Data1.data(:,1);
for i=0:ndof-1
    q(:,i+1)=Data1.data(:,2+3*i);
    dq(:,i+1)=Data1.data(:,3+3*i);
    ddq(:,i+1)=Data1.data(:,4+3*i);
end

omega=zeros(3,ndof+1);
omega_r=zeros(3,ndof+1);
eps_r=zeros(3,ndof+1);
A=zeros(4,4,ndof+1);
T=zeros(4,4,ndof+1);
R=zeros(3,3,ndof+1);


for j=1:n_index

    for i=1:ndof+1
        if i>1 && kin_struc(i-1)=='R'
            theta(i)=q(j,i-1);
        elseif i>1 && kin_struc(i-1)=='T'
            d(i)=q(j,i-1);
        end;
    A(:,:,i)=[cos(theta(i)) -sin(theta(i))*cos(alfa(i))  sin(theta(i))*sin(alfa(i)) a(i)*cos(theta(i));
              sin(theta(i))  cos(theta(i))*cos(alfa(i)) -cos(theta(i))*sin(alfa(i)) a(i)*sin(theta(i));
              0              sin(alfa(i))                cos(alfa(i))               d(i);
              0              0                           0                          1];
    end

    T(:,:,1)=A(:,:,1);
    for i=2:ndof+1
        T(:,:,i)=T(:,:,i-1)*A(:,:,i);
    end

%pozor, koeficienty matic a vektoru k jsou posunuty o +1 - tedy k0=k(:,1)

    for i=1:ndof+1
        k(:,i)=T(1:3,3,i);
    end
    for i=1:ndof+1
    R(:,:,i)=T(1:3,1:3,i);
    end

        for i=1:ndof
        p(:,i)=T(1:3,4,i+1)-T(1:3,4,i);
        if kin_struc(i)=='R'
            omega_r(:,i)=k(:,i)*dq(j,i);
            eps_r(:,i)=k(:,i)*ddq(j,i);
        else
            omega_r(1:3,i)=[0;0;0];
            eps_r(1:3,i)=[0;0;0];
        end
    end

    Dr=[0 -1 0 0;1 0 0 0;0 0 0 0;0 0 0 0];
    Dt=[0 0 0 0;0 0 0 0;0 0 0 1;0 0 0 0];

    XX=zeros(4,4,ndof);
    v_r=zeros(3,ndof);
    for i=1:ndof
        if kin_struc(i)=='R'
           XX=Dr*A(:,:,i+1)*dq(j,i);
        elseif kin_struc(i)=='T'
           XX=Dt*A(:,:,i+1)*dq(j,i);
        end
        v_r(:,i)=R(:,:,i)*XX(1:3,4);
    end

    for i=2:ndof+1
        omega(:,i)=omega(:,i-1)+omega_r(:,i-1);
    end
    v=zeros(3,ndof+1);
    eps=zeros(3,ndof+1);
    for i=2:ndof+1
        v(:,i)=v(:,i-1)+v_r(:,i-1)+cross(omega(:,i-1),p(:,i-1));
        eps(:,i)=eps(:,i-1)+eps_r(:,i-1)+cross(omega(:,i-1),omega(:,i-1));
    end

    a_r=zeros(3,ndof);
    for i=1:ndof
        if kin_struc(i)=='R'
            a_r(:,i)=cross(eps_r(:,i),p(:,i))+cross(omega_r(:,i),cross(omega_r(:,i),p(:,i)));
        else
            a_r(:,i)=k(:,i)*ddq(j,i);
        end
    end

    a=zeros(3,ndof+1);
    for i=2:ndof+1
        a(:,i)=a(:,i-1)+a_r(:,i-1)+cross(eps(:,i-1),p(:,i-1))+2*cross(omega(:,i-1),v_r(:,i-1))+cross(omega(:,i-1),cross(omega(:,i-1),p(:,i-1)));
    end

    for i=1:ndof
        ptb(:,i)=R(:,:,i+1)*pt(:,i);
    end

%pozor vechny rychlosti a zrychlen maj posunut index - index 1 m
%nap. omega(:,0)

    vt=zeros(3,ndof+1);
    at=zeros(3,ndof+1);
    for i=2:ndof+1
        vt(:,i)=v(:,i)+cross(omega(:,i),ptb(:,i-1));
        at(:,i)=a(:,i)+cross(eps(:,i),ptb(:,i-1))+cross(omega(:,i),cross(omega(:,i),ptb(:,i-1)));
    end

    
    %Vstupn vykreslen prbh sil a moment - pklad pro ti DOF, pro vce
    %kloub doplnit
    %Vytvoen sloek sil a moment - prvn index komponent, druh kloub,
    %tet as
    pol_last_LCS(j,:)=T(1:3,4,4)';
    vel_last_LCS(j,:)=v(:,ndof+1)';
    acc_last_LCS(j,:)=a(:,ndof+1)';
end


figure
T1=strcat('Prbh polohy koncovho bodu ve slokch x(modr), y(zelen), z(erven)');
T2=strcat('Prbh rychlosti koncovho bodu ve slokch x(modr), y(zelen), z(erven)');
T3=strcat('Prbh zrychlen koncovho bodu ve slokch x(modr), y(zelen), z(erven)');
subplot(3,1,1);plot(Time,pol_last_LCS(:,1),Time,pol_last_LCS(:,2),Time,pol_last_LCS(:,3));
title(T1);
subplot(3,1,2);plot(Time,vel_last_LCS(:,1),Time,vel_last_LCS(:,2),Time,vel_last_LCS(:,3));
title(T2);
subplot(3,1,3);plot(Time,acc_last_LCS(:,1),Time,acc_last_LCS(:,2),Time,acc_last_LCS(:,3));
title(T3);



